<?php 
namespace NsFWK;

abstract class ClsLog extends ClsBase {
    const LEVEL_DEBUG = 1;  // Most Verbose
    const LEVEL_INFO = 2;   // ...
    const LEVEL_WARN = 3;   // ...
    const LEVEL_ERROR = 4;  // ...
    const LEVEL_FATAL = 5;  // Least Verbose
    const LEVEL_OFF = 6;    // Nothing at all.
    
    // $arrAdditionalField  ["Key1" => "value1", "Key2" => "value2", .....];
    abstract public function LogDebug($strLine, $arrAdditionalField = []);
    abstract public function LogInfo($strLine, $arrAdditionalField = []);
    abstract public function LogWarn($strLine, $arrAdditionalField = []);
    abstract public function LogError($strLine, $arrAdditionalField = []);
    abstract public function LogFatal($strLine, $arrAdditionalField = []);
    abstract protected function log($intLogLevel, $strLine, $arrAdditionalField = []); 
}