<?php
define('ENTRY_POINT', 'CRON');
////////////////////////////
require_once('inc/.inc.php');
////////////////////////////

if (isset($argv[1])) {
    chdir(dirname(__FILE__));
    $module = (isset($argv[1]) && !empty($argv[1])) ? $argv[1] : '';
    $cron = (isset($argv[2]) && !empty($argv[2])) ? $argv[2] : '';
    $arrJobParam = (isset($argv[3]) && $argv[3] != ',' )? explode(',', $argv[3]): [];
    $arrParams = (count($argv) > 4) ? array_slice($argv, 4) : [];
} 

switch(true){
    case (empty($module)):
        die('Missing module parameter.');
    case (empty($cron)):
        die('Missing cron parameter.');
}

$param['module'] = $module;
$param['cron'] = $cron;
$param['action'] = 'default';
if (!empty($arrJobParam)) {
    $param['job'] = [
        'progress'=> $arrJobParam[0],
        'job_id' => isset($arrJobParam[1])? $arrJobParam[1] : '',
        'visibility'=> isset($arrJobParam[2])? $arrJobParam[2] : '',
        'title'=> isset($arrJobParam[3])? $arrJobParam[3] : ''
    ];
}

$param['params'] = $arrParams;
$param['controller_type'] = 'cron';
$param['controller_class'] = $param['cron'];

$strControllerClass = '\Ns' . strtoupper($module) . '\ClsCtrlCron' . $cron;
if (!class_exists($strControllerClass)) {
    die("$cron Cron does not exist.");
}

$objController = new $strControllerClass($param);
$objController->DoAction();