<?php
// General Config
require_once('.config.php');
// Paths
require_once('.path.php');

setlocale(LC_ALL, 'en_En.UTF-8');
date_default_timezone_set(TIME_ZONE);

// RUN_MODE defined in Info File
switch(RUN_MODE){
    case 'DEBUG':
        error_reporting(E_ALL | E_STRICT);
        //error_reporting(-1);
        break;
    case 'PRODUCTION':
        error_reporting(E_ERROR);
        break;
}

// 1.Composer Auto load
require_once(LOCAL__VENDOR . '/autoload.php');
// 2.Custom Auto load
require_once('.autoloader.php');
// 3.Framework Auto load
require_once(LOCAL__FRAMEWORK . '/autoloader.php');

// Error Handler
//require_once(LOCAL__FRAMEWORK . '/error.handler.php');
// Admin DB
require_once('.connection.php');
// Log
require_once('.log.php');