<?php
namespace NsFWK;

class ClsBllStructureLocal
{

    public $Raw, $Processed, $VideoFileSrc, $Segment;
    public $LocalProcessedVideoPath, $LocalProcessedHlsPath;

    public function __construct($intMatchId, $intHalf, $key){
        $this->Raw = LOCAL__RAW;
        $this->Processed = LOCAL__PROCESSED . "/{$intMatchId}";
        $this->VideoFileSrc = $this->Raw . "/$key";
        $this->Segment = $this->Processed . "/M{$intMatchId}_H{$intHalf}__%03d.ts";

        $temp1 = "M{$intMatchId}_H{$intHalf}.mp4";
        $temp2 = "M{$intMatchId}_H{$intHalf}__.m3u8";

        $this->CreateFolder($this->Processed);


        $this->LocalProcessedVideoPath = $this->Processed . "/" . $temp1;
        $this->LocalProcessedHlsPath = $this->Processed . "/" . $temp2;
    }



    protected function CreateFolder($strPath){
        //Check if the directory already exists.
        if(!is_dir($strPath)){
            //Directory does not exist, so lets create it.
            mkdir($strPath, 0755, true);
        }                  
    }

}