<?php
namespace NsFWK;

class ClsBllStructureS3
{

    public $Raw, $Processed, $Folder, $VideoFilename, $HlsFilename;
    public $VideoWebPath, $M3U8WebPath;
    public $Config;

    private $_endpoint;

    public function __construct($arrPlatform, $intMatchId, $intHalf){
        $this->_endpoint = $arrPlatform['ENDPOINT'];
        $this->Raw = $arrPlatform['RAW_BUCKET'];
        $this->Processed = $arrPlatform['PROCESSED_BUCKET'];
        $this->Folder =  $intMatchId . "__" . md5("M$intMatchId");

        $temp1 = "M{$intMatchId}_H{$intHalf}.mp4";
        $temp2 = "M{$intMatchId}_H{$intHalf}__.m3u8";

        $this->VideoFilename = $this->Folder . "/" . $temp1;
        $this->HlsFilename = $this->Folder . "/" . $temp2;


        $this->VideoWebPath= "{$this->_endpoint}/{$this->Processed}/{$this->VideoFilename}";
        $this->M3U8WebPath = "{$this->_endpoint}/{$this->Processed}/{$this->HlsFilename}";

        $this->Config = [
            'accessKey'=>$arrPlatform['ACCESS_KEY'],
            'secretKey'=>$arrPlatform['SECRET_KEY'],
            'endpoint' => $arrPlatform['ENDPOINT'],
            'region'=>$arrPlatform['REGION']
        ];
    }
}