<?php
namespace NsFWK;

abstract class ClsCtrlPagePublic extends ClsCtrl{

    public function DoAction(){
        if(key_exists('action', $this->_data)){
            $fnAction = "do_".$this->_data['action'];
            $fnBefore = "before_".$this->_data['action'];
            $fnAfter  = "after_".$this->_data['action'];
        }else{
            $fnAction = 'do_Default';
            $fnBefore = "before_Default";
            $fnAfter  = "after_Default";
        }

        if(method_exists($this, $fnBefore)){
            $rslt = $this->$fnBefore();
            if(!$rslt){
                return true;
            }
        }

        if(method_exists($this, $fnAction)){
            $rslt = $this->$fnAction();
        }else{
            self::PageNotFound();
            return false;
        }

        if(method_exists($this, $fnAfter)){
            $this->$fnAfter();
        }

        return true;
    }


    static public function PageNotFound(){
        header( "location: index.php?response=404" );
        die();
    }
    
    static public function PageError($strReason=''){
        trigger_error($strReason);
    }
}